\ Encrypt/decrypt using AES 128
\ Libraries by SevenW from sevenwatt.com
\ Frontend by Pavel Zampach, 2022
\ Source text for DX-Forth
\ *


inlib statmem				\ static memory management
decimal

system
[DEFINED] allocate [IF]
limit 1024 empty-memory
\ [u] bytes length buffer
: BUFFER:   ( C: u "name" -- ; R: -- addr )
  allocate mc constant
;
[ELSE]
: BUFFER:   ( C: u "name" -- ; R: -- addr )
  create allot
;
[THEN]
application

inlib aes128en
inlib aes128de
inlib fileio
decimal

0 value FID-O
aeslen buffer: BUF
create AES-KEY
0 c,  1 c,  2 c,  3 c,  4 c,  5 c,  6 c,  7 c,
8 c,  9 c, 10 c, 11 c, 12 c, 13 c, 14 c, 15 c,

defer AES-PRO   ( b-addr k-addr -- )

\ Process the first parameter
: PARAM1   ( addr u -- )
  drop c@ upcase dup
  [char] E = if ['] +aes is aes-pro drop end
  [char] D = if ['] -aes is aes-pro end
  cr ." Usage AES128 E|D infile outfile" cr
  quit
;

\ Return the first substring [addr3 u3] from string [addr1 u1]
\ separated by spaces, string [addr2 u2] is the remainder. When
\ [addr3 u3] is the last part of original string, u2 = -1
: SLICE-BL    ( addr1 u1  -- addr2 u2 addr3 u3 )
  bl skip
  2dup bl scan dup >r
  1 /string 2swap r> -
;

\ Process parameters
: PARAMS   ( -- )
  cmdtail
  slice-bl param1
  slice-bl r/o open-file fc to fid
  slice-bl w/o create-file fc to fid-o
  2drop
;

variable 'OLDEMIT

\ Addr of EMIT vector
: 'EMIT   ( -- addr )
  sys-vec 4 +
;

\ EMIT asterisk only
: *EMIT   ( c -- )
  drop [char] * 'oldemit @execute
;

\ Enter key
: SET-KEY
  cr ." Enter key: "
  'emit @ 'oldemit !			\ save xt of EMIT
  ['] *emit 'emit !			\ set xt of new EMIT
  pad aeslen accept
  >r pad aes-key r> cmove
  'oldemit @ 'emit !			\ restore xt of EMIT
;

\ Encrypt/decrypt file
: AES-MAKE   ( -- )
  cr ." Processing..."
  begin
    buf aeslen fid read-file fc
  while
    buf aes-key aes-pro
    buf aeslen fid-o write-file fc
  repeat
  fid-o close-file fc
  fid close-file fc
;

: MAIN   ( -- )
  params
  set-key
  aes-make
;

turnkey main aes128
